/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * Contact Information:
 * Dambach-Werke GmbH
 * Elektronische Leitsysteme
 * Fritz-Minhardt-Str. 1
 * 76456 Kuppenheim
 * Phone: +49-7222-402-0
 * Fax: +49-7222-402-200
 * mailto: info@els.dambach.de
 */

package de.bsvrz.ste.tmc.junit.prueffall2;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.ste.tmc.junit.RDSTMCPrueffall;
import de.bsvrz.ste.tmc.junit.tools.WarteAufNeueUndAktualisierteDaten;
import de.bsvrz.ste.tmc.meldungserstellung.VerwaltungMeldungen;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * @author Sans
 *
 */
public class Prueffall2_2_820s extends RDSTMCPrueffall {
	/**
	 * Debug-Logger für Logging-Ausgaben
	 */
	private final static Debug _debug = Debug.getLogger();

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testPrueffal2_2_4_820s() throws Exception {
		assertTestGeneratorLaeuft();

		SystemObject meldung5 = getDataModel().getObject(VerwaltungMeldungen.PID_PREFIX + "5");
		assertNotNull("Objekt " + VerwaltungMeldungen.PID_PREFIX + "5" + " existiert", meldung5);
		String erwartetePid = VerwaltungMeldungen.PID_PREFIX + "6";

		WarteAufNeueUndAktualisierteDaten wanuad = new WarteAufNeueUndAktualisierteDaten(getConnection(),
				getMeldungsMenge(), new String[] { erwartetePid }, new SystemObject[] { meldung5 },
				getDataDescription(), 40000 + TOL_PLUS);

		ResultData rd5 = wanuad.getAktualisierteDaten().get(meldung5.getPid());
		ResultData rd6 = wanuad.getNeueDaten().get(erwartetePid);

		assertTrue(
				"1 neues Objekt " + erwartetePid + " in der Menge " + getMeldungsMenge().getName() + " wurde erzeugt",
				wanuad.getNeueDaten().size() == 1 && rd6 != null && rd6.getObject().getPid().equals(erwartetePid));

		assertTrue("1 Meldungen " + meldung5.getPid() + " wurde aktualisiert",
				wanuad.getAktualisierteDaten().size() == 1 && rd5 != null && rd5.getObject().equals(meldung5));

		assertPruefZeitKorrekt(820000, Math.max(rd5.getDataTime(), rd6.getDataTime()));

		assertMeldungsDatenKorrekt(rd5, InformationsTyp.ALERTC, MeldungsArt.AUFHEBUNG, GeografischeBedeutung.NATIONAL,
				ZeitlicheDringlichkeit.NORMAL, ZeitlicheDauer.UNBEKANNT, -1, 813, 11906, null, null);

		assertMeldungsDatenKorrekt(rd6, InformationsTyp.ALERTC, MeldungsArt.AKTUALISIERUNG,
				GeografischeBedeutung.NATIONAL, ZeitlicheDringlichkeit.NORMAL, ZeitlicheDauer.UNBEKANNT, -2, 717, 11907,
				"rdsQuantität.LEN", "5");

		getConnection().sleep(1000);
	}

}
